# coding: utf-8

"""
    Wink Payment API

    A programmatic way to create bookings, receive reactive and disburse funds globally.  ## APIs Not every integrator needs every APIs. For that reason, we have separated APIs into context.  - [Affiliate](/affiliate): All APIs related to selling travel inventory as an affiliate. - [Analytics](/analytics): All APIs related to tracking metrics across a wide variety of data source segments including, more entertaining, leaderboard metrics. - [Booking](/booking): All APIs related to creating platform bookings. - [Channel Manager](/channel-manager): All APIs related to channel managers who want to integrate with our platform. - [Extranet](/extranet): All APIs related to managing travel inventory and suppliers. - [Inventory](/inventory): All APIs related to retrieve known travel inventory as it was found using the Lookup API.. - [Lookup](/lookup): All APIs related to locating inventory by region, locale and property flags. - [Reference](/reference): All APIs related to retrieving platform-supported taxonomies. - [TripPay](/reactive): All APIs related to TripPay account management, booking, mapping and integration features.  ## SDKs We are actively working on supporting the most used languages out there. If you don't see your language here, reach out to us with a request to officially add your language. In the meantime, if you want to roll your own SDK, you can do so by downloading the OpenAPI spec and using one of the many available OpenAPI generators available: [https://openapi-generator.tech/docs/generators](https://openapi-generator.tech/docs/generators).  - Java SDK [https://github.com/wink-travel/trip-pay-sdk-java](https://github.com/wink-travel/trip-pay-sdk-java)  # Usage These features are made available to you via a [REST API](https://en.wikipedia.org/wiki/Representational_state_transfer). This API is language agnostic. We will link to SDKs for the most popular programming languages on this page as they become available.  ## Versioning We chose to version our endpoints in a way that we hope affects your integration with us the least. You request the version of our API you wish to work with via the `Wink-Version` header. When it's time for you to upgrade, you only have to change the version number to get access to our updated endpoints.  ## Release history - Follow updates on Github: https://github.com/wink-travel/wink-sdk-java/blob/master/CHANGELOG.md 

    The version of the OpenAPI document: 30.16.3
    Contact: bjorn@wink.travel
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Notification(BaseModel):
    """
    Notification
    """ # noqa: E501
    identifier: StrictStr = Field(description="Notification identifier")
    owner_identifier: StrictStr = Field(description="Owner identifier", alias="ownerIdentifier")
    priority: StrictStr = Field(description="Importance of message")
    type: StrictStr = Field(description="Message type")
    recipient_type: StrictStr = Field(description="Recipient type", alias="recipientType")
    application: StrictStr = Field(description="Application domain")
    message_template_id: StrictStr = Field(description="Message template", alias="messageTemplateId")
    subject: StrictStr = Field(description="Subject of message")
    body: StrictStr = Field(description="Subject of message")
    cta_url: StrictStr = Field(description="Path to feature", alias="ctaUrl")
    read: Optional[StrictBool] = Field(default=None, description="Company read announcement")
    marked_as_removed: Optional[StrictBool] = Field(default=None, description="Message marked as removed", alias="markedAsRemoved")
    notify_via_email: Optional[StrictBool] = Field(default=None, description="Also send email announcement", alias="notifyViaEmail")
    __properties: ClassVar[List[str]] = ["identifier", "ownerIdentifier", "priority", "type", "recipientType", "application", "messageTemplateId", "subject", "body", "ctaUrl", "read", "markedAsRemoved", "notifyViaEmail"]

    @field_validator('priority')
    def priority_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['HIGH', 'MEDIUM', 'LOW']):
            raise ValueError("must be one of enum values ('HIGH', 'MEDIUM', 'LOW')")
        return value

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['ALERT', 'MESSAGE', 'FEATURE']):
            raise ValueError("must be one of enum values ('ALERT', 'MESSAGE', 'FEATURE')")
        return value

    @field_validator('recipient_type')
    def recipient_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['USER', 'ACCOUNT']):
            raise ValueError("must be one of enum values ('USER', 'ACCOUNT')")
        return value

    @field_validator('application')
    def application_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['EXTRANET', 'CORPORATE', 'TRAVEL_AGENT', 'STUDIO', 'PAYMENT']):
            raise ValueError("must be one of enum values ('EXTRANET', 'CORPORATE', 'TRAVEL_AGENT', 'STUDIO', 'PAYMENT')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Notification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Notification from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "identifier": obj.get("identifier"),
            "ownerIdentifier": obj.get("ownerIdentifier"),
            "priority": obj.get("priority"),
            "type": obj.get("type"),
            "recipientType": obj.get("recipientType"),
            "application": obj.get("application"),
            "messageTemplateId": obj.get("messageTemplateId"),
            "subject": obj.get("subject"),
            "body": obj.get("body"),
            "ctaUrl": obj.get("ctaUrl"),
            "read": obj.get("read"),
            "markedAsRemoved": obj.get("markedAsRemoved"),
            "notifyViaEmail": obj.get("notifyViaEmail")
        })
        return _obj


